[clikt](../../index.md) / [com.github.ajalt.clikt.parameters.options](../index.md) / [FlagOption](./index.md)

# FlagOption

`class FlagOption<T> : `[`OptionDelegate`](../-option-delegate/index.md)`<`[`T`](index.md#T)`>`

An [Option](../-option/index.md) that has no values.

### Constructors

| Name | Summary |
|---|---|
| [&lt;init&gt;](-init-.md) | `FlagOption(names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, secondaryNames: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)`, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?, transformEnvvar: `[`OptionTransformContext`](../-option-transform-context/index.md)`.(`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`) -> `[`T`](index.md#T)`, transformAll: `[`CallsTransformer`](../-calls-transformer.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](index.md#T)`>, validator: `[`OptionValidator`](../-option-validator.md)`<`[`T`](index.md#T)`>)`<br>An [Option](../-option/index.md) that has no values. |

### Properties

| Name | Summary |
|---|---|
| [envvar](envvar.md) | `val envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?`<br>The name of the environment variable for this option. Overrides automatic names. |
| [groupName](group-name.md) | `var groupName: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?`<br>The name of the group, or null if this option should not be grouped in the help output. |
| [help](help.md) | `val help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>The description of this option, usually a single line. |
| [helpTags](help-tags.md) | `val helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Extra information about this option to pass to the help formatter. |
| [hidden](hidden.md) | `val hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)<br>If true, this option should not appear in help output. |
| [metavar](metavar.md) | `val metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?`<br>A name representing the values for this option that can be displayed to the user. |
| [names](names.md) | `var names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>The names that can be used to invoke this option. They must start with a punctuation character. |
| [nvalues](nvalues.md) | `val nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)<br>The number of values that must be given to this option. |
| [parameterGroup](parameter-group.md) | `var parameterGroup: `[`ParameterGroup`](../../com.github.ajalt.clikt.parameters.groups/-parameter-group/index.md)`?`<br>The group that this option belongs to, or null. Set by the group. |
| [parser](parser.md) | `val parser: `[`FlagOptionParser`](../../com.github.ajalt.clikt.parsers/-flag-option-parser/index.md)<br>The parser for this option's values. |
| [secondaryNames](secondary-names.md) | `val secondaryNames: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Names that can be used for a secondary purpose, like disabling flag options. |
| [transformAll](transform-all.md) | `val transformAll: `[`CallsTransformer`](../-calls-transformer.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](index.md#T)`>`<br>Called to transform all invocations of this option into the final option type. |
| [transformEnvvar](transform-envvar.md) | `val transformEnvvar: `[`OptionTransformContext`](../-option-transform-context/index.md)`.(`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`) -> `[`T`](index.md#T)<br>Called to transform string values from envvars into the option type. |
| [validator](validator.md) | `val validator: `[`OptionValidator`](../-option-validator.md)`<`[`T`](index.md#T)`>` |
| [value](value.md) | `var value: `[`T`](index.md#T)<br>The value for this option. |

### Functions

| Name | Summary |
|---|---|
| [copy](copy.md) | `fun <T> copy(transformEnvvar: `[`OptionTransformContext`](../-option-transform-context/index.md)`.(`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`) -> `[`T`](copy.md#T)`, transformAll: `[`CallsTransformer`](../-calls-transformer.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](copy.md#T)`>, validator: `[`OptionValidator`](../-option-validator.md)`<`[`T`](copy.md#T)`>, names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.names, secondaryNames: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.secondaryNames, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.help, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = this.hidden, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.helpTags, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = this.envvar): `[`FlagOption`](./index.md)`<`[`T`](copy.md#T)`>`<br>Create a new option that is a copy of this one with different transforms.`fun copy(validator: `[`OptionValidator`](../-option-validator.md)`<`[`T`](index.md#T)`> = this.validator, names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.names, secondaryNames: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.secondaryNames, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.help, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = this.hidden, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.helpTags, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = this.envvar): `[`FlagOption`](./index.md)`<`[`T`](index.md#T)`>`<br>Create a new option that is a copy of this one with the same transforms. |
| [finalize](finalize.md) | `fun finalize(context: `[`Context`](../../com.github.ajalt.clikt.core/-context/index.md)`, invocations: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`OptionParser.Invocation`](../../com.github.ajalt.clikt.parsers/-option-parser/-invocation/index.md)`>): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Called after this command's argv is parsed to transform and store the option's value. |
| [postValidate](post-validate.md) | `fun postValidate(context: `[`Context`](../../com.github.ajalt.clikt.core/-context/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Called after all of a command's parameters have been [finalize](../-option/finalize.md)d to perform validation of the final value. |
| [provideDelegate](provide-delegate.md) | `operator fun provideDelegate(thisRef: `[`ParameterHolder`](../../com.github.ajalt.clikt.core/-parameter-holder/index.md)`, prop: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`ParameterHolder`](../../com.github.ajalt.clikt.core/-parameter-holder/index.md)`, `[`T`](index.md#T)`>`<br>Implementations must call [ParameterHolder.registerOption](../../com.github.ajalt.clikt.core/-parameter-holder/register-option.md) |

### Inherited Functions

| Name | Summary |
|---|---|
| [getValue](../-option-delegate/get-value.md) | `open fun getValue(thisRef: `[`ParameterHolder`](../../com.github.ajalt.clikt.core/-parameter-holder/index.md)`, property: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`T`](../-option-delegate/index.md#T) |

### Extension Functions

| Name | Summary |
|---|---|
| [default](../default.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`FlagOption`](./index.md)`<`[`T`](../default.md#T)`?>.default(value: `[`T`](../default.md#T)`): `[`FlagOption`](./index.md)`<`[`T`](../default.md#T)`>`<br>Set a default value for a option. |
| [deprecated](../deprecated.md) | `fun <T> `[`FlagOption`](./index.md)`<`[`T`](../deprecated.md#T)`>.deprecated(message: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = "", tagName: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = "deprecated", tagValue: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", error: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`OptionDelegate`](../-option-delegate/index.md)`<`[`T`](../deprecated.md#T)`>`<br>Mark this option as deprecated in the help output. |
| [validate](../validate.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`FlagOption`](./index.md)`<`[`T`](../validate.md#T)`>.validate(validator: `[`OptionValidator`](../-option-validator.md)`<`[`T`](../validate.md#T)`>): `[`OptionDelegate`](../-option-delegate/index.md)`<`[`T`](../validate.md#T)`>`<br>Check the final option value and raise an error if it's not valid. |
