[clikt](../../index.md) / [com.github.ajalt.clikt.parameters.options](../index.md) / [OptionWithValues](./index.md)

# OptionWithValues

`class OptionWithValues<AllT, EachT, ValueT> : `[`OptionDelegate`](../-option-delegate/index.md)`<`[`AllT`](index.md#AllT)`>, `[`GroupableOption`](../../com.github.ajalt.clikt.core/-groupable-option/index.md)

An [Option](../-option/index.md) that takes one or more values.

### Constructors

| Name | Summary |
|---|---|
| [&lt;init&gt;](-init-.md) | `OptionWithValues(names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, metavarWithDefault: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?>, nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)`, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?, envvarSplit: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`>, valueSplit: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`?, parser: `[`OptionWithValuesParser`](../../com.github.ajalt.clikt.parsers/-option-with-values-parser/index.md)`, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)`, transformValue: `[`ValueTransformer`](../-value-transformer.md)`<`[`ValueT`](index.md#ValueT)`>, transformEach: `[`ArgsTransformer`](../-args-transformer.md)`<`[`ValueT`](index.md#ValueT)`, `[`EachT`](index.md#EachT)`>, transformAll: `[`CallsTransformer`](../-calls-transformer.md)`<`[`EachT`](index.md#EachT)`, `[`AllT`](index.md#AllT)`>, transformValidator: `[`OptionValidator`](../-option-validator.md)`<`[`AllT`](index.md#AllT)`>)`<br>An [Option](../-option/index.md) that takes one or more values. |

### Properties

| Name | Summary |
|---|---|
| [completionCandidates](completion-candidates.md) | `val completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)<br>Optional set of strings to use when the user invokes shell autocomplete on a value for this option. |
| [envvar](envvar.md) | `val envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?`<br>The environment variable name to use. |
| [envvarSplit](envvar-split.md) | `val envvarSplit: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`>`<br>The pattern to split envvar values on. If the envvar splits into multiple values, each one will be treated like a separate invocation of the option. |
| [groupName](group-name.md) | `var groupName: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?`<br>The name of the group, or null if this option should not be grouped in the help output. |
| [help](help.md) | `val help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>The description of this option, usually a single line. |
| [helpTags](help-tags.md) | `val helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Extra information about this option to pass to the help formatter. |
| [hidden](hidden.md) | `val hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)<br>If true, this option should not appear in help output. |
| [metavar](metavar.md) | `val metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?`<br>A name representing the values for this option that can be displayed to the user. |
| [metavarWithDefault](metavar-with-default.md) | `val metavarWithDefault: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?>`<br>The metavar to use. Specified at option creation. |
| [names](names.md) | `var names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>The names that can be used to invoke this option. They must start with a punctuation character. |
| [nvalues](nvalues.md) | `val nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)<br>The number of values that must be given to this option. |
| [parameterGroup](parameter-group.md) | `var parameterGroup: `[`ParameterGroup`](../../com.github.ajalt.clikt.parameters.groups/-parameter-group/index.md)`?`<br>The group that this option belongs to, or null. Set by the group. |
| [parser](parser.md) | `val parser: `[`OptionWithValuesParser`](../../com.github.ajalt.clikt.parsers/-option-with-values-parser/index.md)<br>The parser for this option's values. |
| [secondaryNames](secondary-names.md) | `val secondaryNames: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Names that can be used for a secondary purpose, like disabling flag options. |
| [transformAll](transform-all.md) | `val transformAll: `[`CallsTransformer`](../-calls-transformer.md)`<`[`EachT`](index.md#EachT)`, `[`AllT`](index.md#AllT)`>`<br>Called in [finalize](finalize.md) to transform all invocations into the final value. |
| [transformEach](transform-each.md) | `val transformEach: `[`ArgsTransformer`](../-args-transformer.md)`<`[`ValueT`](index.md#ValueT)`, `[`EachT`](index.md#EachT)`>`<br>Called in [finalize](finalize.md) to transform each invocation. |
| [transformValidator](transform-validator.md) | `val transformValidator: `[`OptionValidator`](../-option-validator.md)`<`[`AllT`](index.md#AllT)`>`<br>Called after all parameters have been [finalize](finalize.md)d to validate the output of [transformAll](transform-all.md) |
| [transformValue](transform-value.md) | `val transformValue: `[`ValueTransformer`](../-value-transformer.md)`<`[`ValueT`](index.md#ValueT)`>`<br>Called in [finalize](finalize.md) to transform each value provided to each invocation. |
| [value](value.md) | `var value: `[`AllT`](index.md#AllT)<br>The value for this option. |
| [valueSplit](value-split.md) | `val valueSplit: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`?`<br>The pattern to split values from the command line on. By default, values are split on whitespace. |

### Functions

| Name | Summary |
|---|---|
| [copy](copy.md) | `fun <AllT, EachT, ValueT> copy(transformValue: `[`ValueTransformer`](../-value-transformer.md)`<`[`ValueT`](copy.md#ValueT)`>, transformEach: `[`ArgsTransformer`](../-args-transformer.md)`<`[`ValueT`](copy.md#ValueT)`, `[`EachT`](copy.md#EachT)`>, transformAll: `[`CallsTransformer`](../-calls-transformer.md)`<`[`EachT`](copy.md#EachT)`, `[`AllT`](copy.md#AllT)`>, validator: `[`OptionValidator`](../-option-validator.md)`<`[`AllT`](copy.md#AllT)`>, names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.names, metavarWithDefault: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?> = this.metavarWithDefault, nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)` = this.nvalues, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.help, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = this.hidden, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.helpTags, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = this.envvar, envvarSplit: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`> = this.envvarSplit, valueSplit: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`? = this.valueSplit, parser: `[`OptionWithValuesParser`](../../com.github.ajalt.clikt.parsers/-option-with-values-parser/index.md)` = this.parser, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)` = this.completionCandidates): `[`OptionWithValues`](./index.md)`<`[`AllT`](copy.md#AllT)`, `[`EachT`](copy.md#EachT)`, `[`ValueT`](copy.md#ValueT)`>`<br>Create a new option that is a copy of this one with different transforms.`fun copy(validator: `[`OptionValidator`](../-option-validator.md)`<`[`AllT`](index.md#AllT)`> = this.transformValidator, names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.names, metavarWithDefault: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`?> = this.metavarWithDefault, nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)` = this.nvalues, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.help, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = this.hidden, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.helpTags, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = this.envvar, envvarSplit: `[`ValueWithDefault`](../-value-with-default/index.md)`<`[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`> = this.envvarSplit, valueSplit: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`? = this.valueSplit, parser: `[`OptionWithValuesParser`](../../com.github.ajalt.clikt.parsers/-option-with-values-parser/index.md)` = this.parser, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)` = this.completionCandidates): `[`OptionWithValues`](./index.md)`<`[`AllT`](index.md#AllT)`, `[`EachT`](index.md#EachT)`, `[`ValueT`](index.md#ValueT)`>`<br>Create a new option that is a copy of this one with the same transforms. |
| [finalize](finalize.md) | `fun finalize(context: `[`Context`](../../com.github.ajalt.clikt.core/-context/index.md)`, invocations: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`OptionParser.Invocation`](../../com.github.ajalt.clikt.parsers/-option-parser/-invocation/index.md)`>): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Called after this command's argv is parsed to transform and store the option's value. |
| [postValidate](post-validate.md) | `fun postValidate(context: `[`Context`](../../com.github.ajalt.clikt.core/-context/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Called after all of a command's parameters have been [finalize](../-option/finalize.md)d to perform validation of the final value. |
| [provideDelegate](provide-delegate.md) | `operator fun provideDelegate(thisRef: `[`ParameterHolder`](../../com.github.ajalt.clikt.core/-parameter-holder/index.md)`, prop: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`ParameterHolder`](../../com.github.ajalt.clikt.core/-parameter-holder/index.md)`, `[`AllT`](index.md#AllT)`>`<br>Implementations must call [ParameterHolder.registerOption](../../com.github.ajalt.clikt.core/-parameter-holder/register-option.md) |

### Inherited Functions

| Name | Summary |
|---|---|
| [getValue](../-option-delegate/get-value.md) | `open fun getValue(thisRef: `[`ParameterHolder`](../../com.github.ajalt.clikt.core/-parameter-holder/index.md)`, property: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`T`](../-option-delegate/index.md#T) |

### Extension Functions

| Name | Summary |
|---|---|
| [choice](../../com.github.ajalt.clikt.parameters.types/choice.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../-raw-option.md)`.choice(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>, metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = mvar(choices.keys)): `[`NullableOption`](../-nullable-option.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>`<br>`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../-raw-option.md)`.choice(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>, metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = mvar(choices.map { it.first })): `[`NullableOption`](../-nullable-option.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>`<br>Convert the option based on a fixed set of values.`fun `[`RawOption`](../-raw-option.md)`.choice(vararg choices: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = mvar(choices.asIterable())): `[`NullableOption`](../-nullable-option.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Restrict the option to a fixed set of values. |
| [convert](../convert.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../-raw-option.md)`.convert(metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "VALUE", envvarSplit: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)` = this.envvarSplit.default, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)` = this.completionCandidates, conversion: `[`ValueTransformer`](../-value-transformer.md)`<`[`T`](../convert.md#T)`>): `[`NullableOption`](../-nullable-option.md)`<`[`T`](../convert.md#T)`, `[`T`](../convert.md#T)`>`<br>Convert the option value type. |
| [counted](../counted.md) | `fun `[`RawOption`](../-raw-option.md)`.counted(): `[`FlagOption`](../-flag-option/index.md)`<`[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`>`<br>Turn an option into a flag that counts the number of times the option occurs on the command line. |
| [default](../default.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../default.md#EachT)`, `[`ValueT`](../default.md#ValueT)`>.default(value: `[`EachT`](../default.md#EachT)`, defaultForHelp: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = value.toString()): `[`OptionWithValues`](./index.md)`<`[`EachT`](../default.md#EachT)`, `[`EachT`](../default.md#EachT)`, `[`ValueT`](../default.md#ValueT)`>`<br>If the option is not called on the command line (and is not set in an envvar), use [value](../default.md#com.github.ajalt.clikt.parameters.options$default(com.github.ajalt.clikt.parameters.options.OptionWithValues((com.github.ajalt.clikt.parameters.options.default.EachT, com.github.ajalt.clikt.parameters.options.default.EachT, com.github.ajalt.clikt.parameters.options.default.ValueT)), com.github.ajalt.clikt.parameters.options.default.EachT, kotlin.String)/value) for the option. |
| [defaultLazy](../default-lazy.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../default-lazy.md#EachT)`, `[`ValueT`](../default-lazy.md#ValueT)`>.defaultLazy(defaultForHelp: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", value: () -> `[`EachT`](../default-lazy.md#EachT)`): `[`OptionWithValues`](./index.md)`<`[`EachT`](../default-lazy.md#EachT)`, `[`EachT`](../default-lazy.md#EachT)`, `[`ValueT`](../default-lazy.md#ValueT)`>`<br>If the option is not called on the command line (and is not set in an envvar), call the [value](../default-lazy.md#com.github.ajalt.clikt.parameters.options$defaultLazy(com.github.ajalt.clikt.parameters.options.OptionWithValues((com.github.ajalt.clikt.parameters.options.defaultLazy.EachT, com.github.ajalt.clikt.parameters.options.defaultLazy.EachT, com.github.ajalt.clikt.parameters.options.defaultLazy.ValueT)), kotlin.String, kotlin.Function0((com.github.ajalt.clikt.parameters.options.defaultLazy.EachT)))/value) and use its return value for the option. |
| [deprecated](../deprecated.md) | `fun <AllT, EachT, ValueT> `[`OptionWithValues`](./index.md)`<`[`AllT`](../deprecated.md#AllT)`, `[`EachT`](../deprecated.md#EachT)`, `[`ValueT`](../deprecated.md#ValueT)`>.deprecated(message: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = "", tagName: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = "deprecated", tagValue: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", error: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`OptionDelegate`](../-option-delegate/index.md)`<`[`AllT`](../deprecated.md#AllT)`>`<br>Mark this option as deprecated in the help output. |
| [double](../../com.github.ajalt.clikt.parameters.types/double.md) | `fun `[`RawOption`](../-raw-option.md)`.double(): `[`NullableOption`](../-nullable-option.md)`<`[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`, `[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`>`<br>Convert the option values to a `Double` |
| [file](../../com.github.ajalt.clikt.parameters.types/file.md) | `fun `[`RawOption`](../-raw-option.md)`.file(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`NullableOption`](../-nullable-option.md)`<`[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`, `[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`>`<br>Convert the option to a [File](https://docs.oracle.com/javase/6/docs/api/java/io/File.html). |
| [flag](../flag.md) | `fun `[`RawOption`](../-raw-option.md)`.flag(vararg secondaryNames: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, default: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`FlagOption`](../-flag-option/index.md)`<`[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)`>`<br>Turn an option into a boolean flag. |
| [float](../../com.github.ajalt.clikt.parameters.types/float.md) | `fun `[`RawOption`](../-raw-option.md)`.float(): `[`NullableOption`](../-nullable-option.md)`<`[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`, `[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`>`<br>Convert the option values to a `Float` |
| [groupChoice](../../com.github.ajalt.clikt.parameters.groups/group-choice.md) | `fun <T : `[`OptionGroup`](../../com.github.ajalt.clikt.parameters.groups/-option-group/index.md)`> `[`RawOption`](../-raw-option.md)`.groupChoice(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../../com.github.ajalt.clikt.parameters.groups/group-choice.md#T)`>): `[`ChoiceGroup`](../../com.github.ajalt.clikt.parameters.groups/-choice-group/index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.groups/group-choice.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.groups/group-choice.md#T)`?>`<br>`fun <T : `[`OptionGroup`](../../com.github.ajalt.clikt.parameters.groups/-option-group/index.md)`> `[`RawOption`](../-raw-option.md)`.groupChoice(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../../com.github.ajalt.clikt.parameters.groups/group-choice.md#T)`>): `[`ChoiceGroup`](../../com.github.ajalt.clikt.parameters.groups/-choice-group/index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.groups/group-choice.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.groups/group-choice.md#T)`?>`<br>Convert the option to an option group based on a fixed set of values. |
| [int](../../com.github.ajalt.clikt.parameters.types/int.md) | `fun `[`RawOption`](../-raw-option.md)`.int(): `[`NullableOption`](../-nullable-option.md)`<`[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`>`<br>Convert the option values to an `Int` |
| [long](../../com.github.ajalt.clikt.parameters.types/long.md) | `fun `[`RawOption`](../-raw-option.md)`.long(): `[`NullableOption`](../-nullable-option.md)`<`[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`, `[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`>`<br>Convert the option values to a `Long` |
| [multiple](../multiple.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../multiple.md#EachT)`, `[`ValueT`](../multiple.md#ValueT)`>.multiple(default: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`EachT`](../multiple.md#EachT)`> = emptyList()): `[`OptionWithValues`](./index.md)`<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`EachT`](../multiple.md#EachT)`>, `[`EachT`](../multiple.md#EachT)`, `[`ValueT`](../multiple.md#ValueT)`>`<br>Make the option return a list of calls; each item in the list is the value of one call. |
| [pair](../pair.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../pair.md#EachT)`, `[`ValueT`](../pair.md#ValueT)`>.pair(): `[`NullableOption`](../-nullable-option.md)`<`[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`ValueT`](../pair.md#ValueT)`, `[`ValueT`](../pair.md#ValueT)`>, `[`ValueT`](../pair.md#ValueT)`>`<br>Change to option to take two values, held in a [Pair](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html). |
| [path](../../com.github.ajalt.clikt.parameters.types/path.md) | `fun `[`RawOption`](../-raw-option.md)`.path(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileSystem: FileSystem = FileSystems.getDefault()): `[`NullableOption`](../-nullable-option.md)`<Path, Path>`<br>Convert the option to a [Path](#). |
| [prompt](../prompt.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`NullableOption`](../-nullable-option.md)`<`[`T`](../prompt.md#T)`, `[`T`](../prompt.md#T)`>.prompt(text: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, default: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, hideInput: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, requireConfirmation: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, confirmationPrompt: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "Repeat for confirmation: ", promptSuffix: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = ": ", showDefault: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true): `[`OptionWithValues`](./index.md)`<`[`T`](../prompt.md#T)`, `[`T`](../prompt.md#T)`, `[`T`](../prompt.md#T)`>`<br>If the option isn't given on the command line, prompt the user for manual input. |
| [required](../required.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../required.md#EachT)`, `[`ValueT`](../required.md#ValueT)`>.required(): `[`OptionWithValues`](./index.md)`<`[`EachT`](../required.md#EachT)`, `[`EachT`](../required.md#EachT)`, `[`ValueT`](../required.md#ValueT)`>`<br>If the option is not called on the command line (and is not set in an envvar), throw a [MissingParameter](../../com.github.ajalt.clikt.core/-missing-parameter/index.md). |
| [restrictTo](../../com.github.ajalt.clikt.parameters.types/restrict-to.md) | `fun <T> `[`OptionWithValues`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`?, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>.restrictTo(min: `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`? = null, max: `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`? = null, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`OptionWithValues`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`?, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>`<br>`fun <T> `[`OptionWithValues`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`?, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>.restrictTo(range: `[`ClosedRange`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.ranges/-closed-range/index.html)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`OptionWithValues`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`?, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>`<br>Restrict the option values to fit into a range. |
| [split](../split.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../split.md#EachT)`, `[`ValueT`](../split.md#ValueT)`>.split(regex: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`): `[`OptionWithValues`](./index.md)`<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`ValueT`](../split.md#ValueT)`>?, `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`ValueT`](../split.md#ValueT)`>, `[`ValueT`](../split.md#ValueT)`>`<br>Change to option to take any number of values, separated by a [regex](../split.md#com.github.ajalt.clikt.parameters.options$split(com.github.ajalt.clikt.parameters.options.OptionWithValues((com.github.ajalt.clikt.parameters.options.split.EachT, com.github.ajalt.clikt.parameters.options.split.EachT, com.github.ajalt.clikt.parameters.options.split.ValueT)), kotlin.text.Regex)/regex).`fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../split.md#EachT)`, `[`ValueT`](../split.md#ValueT)`>.split(delimiter: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`OptionWithValues`](./index.md)`<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`ValueT`](../split.md#ValueT)`>?, `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`ValueT`](../split.md#ValueT)`>, `[`ValueT`](../split.md#ValueT)`>`<br>Change to option to take any number of values, separated by a string [delimiter](../split.md#com.github.ajalt.clikt.parameters.options$split(com.github.ajalt.clikt.parameters.options.OptionWithValues((com.github.ajalt.clikt.parameters.options.split.EachT, com.github.ajalt.clikt.parameters.options.split.EachT, com.github.ajalt.clikt.parameters.options.split.ValueT)), kotlin.String)/delimiter). |
| [switch](../switch.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../-raw-option.md)`.switch(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../switch.md#T)`>): `[`FlagOption`](../-flag-option/index.md)`<`[`T`](../switch.md#T)`?>`<br>`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../-raw-option.md)`.switch(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../switch.md#T)`>): `[`FlagOption`](../-flag-option/index.md)`<`[`T`](../switch.md#T)`?>`<br>Turn an option into a set of flags that each map to a value. |
| [transformAll](../transform-all.md) | `fun <AllT, EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../transform-all.md#EachT)`, `[`ValueT`](../transform-all.md#ValueT)`>.transformAll(defaultForHelp: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = this.helpTags[HelpFormatter.Tags.DEFAULT], showAsRequired: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = HelpFormatter.Tags.REQUIRED in this.helpTags, transform: `[`CallsTransformer`](../-calls-transformer.md)`<`[`EachT`](../transform-all.md#EachT)`, `[`AllT`](../transform-all.md#AllT)`>): `[`OptionWithValues`](./index.md)`<`[`AllT`](../transform-all.md#AllT)`, `[`EachT`](../transform-all.md#EachT)`, `[`ValueT`](../transform-all.md#ValueT)`>`<br>Transform all calls to the option to the final option type. |
| [transformValues](../transform-values.md) | `fun <EachInT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, EachOutT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachInT`](../transform-values.md#EachInT)`, `[`ValueT`](../transform-values.md#ValueT)`>.transformValues(nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, transform: `[`ArgsTransformer`](../-args-transformer.md)`<`[`ValueT`](../transform-values.md#ValueT)`, `[`EachOutT`](../transform-values.md#EachOutT)`>): `[`NullableOption`](../-nullable-option.md)`<`[`EachOutT`](../transform-values.md#EachOutT)`, `[`ValueT`](../transform-values.md#ValueT)`>`<br>Change the number of values that this option takes. |
| [triple](../triple.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`NullableOption`](../-nullable-option.md)`<`[`EachT`](../triple.md#EachT)`, `[`ValueT`](../triple.md#ValueT)`>.triple(): `[`NullableOption`](../-nullable-option.md)`<`[`Triple`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-triple/index.html)`<`[`ValueT`](../triple.md#ValueT)`, `[`ValueT`](../triple.md#ValueT)`, `[`ValueT`](../triple.md#ValueT)`>, `[`ValueT`](../triple.md#ValueT)`>`<br>Change to option to take three values, held in a [Triple](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-triple/index.html). |
| [unique](../unique.md) | `fun <EachT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`OptionWithValues`](./index.md)`<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`EachT`](../unique.md#EachT)`>, `[`EachT`](../unique.md#EachT)`, `[`ValueT`](../unique.md#ValueT)`>.unique(): `[`OptionWithValues`](./index.md)`<`[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`EachT`](../unique.md#EachT)`>, `[`EachT`](../unique.md#EachT)`, `[`ValueT`](../unique.md#ValueT)`>`<br>Make the [multiple](../multiple.md) option return a unique set of calls |
| [validate](../validate.md) | `fun <AllT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, EachT, ValueT> `[`OptionWithValues`](./index.md)`<`[`AllT`](../validate.md#AllT)`, `[`EachT`](../validate.md#EachT)`, `[`ValueT`](../validate.md#ValueT)`>.validate(validator: `[`OptionValidator`](../-option-validator.md)`<`[`AllT`](../validate.md#AllT)`>): `[`OptionDelegate`](../-option-delegate/index.md)`<`[`AllT`](../validate.md#AllT)`>`<br>Check the final option value and raise an error if it's not valid. |
